# Blueprint Reference | Asynchronous Loading

# 7. Blueprint Reference | Asynchronous Loading

This is an Unreal Level Blueprint that demonstrates how to build a loading screen that can be used at the start of a game to load both FMOD Studio data and Unreal data without blocking the main thread. To make this work properly "Load All Banks" needs to be turned off in the FMOD Settings.

Topics:

- Variables
- Macros

## Variables

Banks
  List of banks to load
Load Sample Data
  When enabled, the sample data from all FMOD bank files is loaded at startup. Only effective when `Load All Banks` is also disabled
Done
  False, until all the banks have finished loading.
Number of Banks Loaded
  Reference to how many banks have currently been loaded. Used as reference to check if loading has completed.
Map Name
  The name of the map to be loaded when banks have completed loading.

## Macros

Make Array
  Using the Banks variable, define an array of banks to be loaded.
Load Banks
  Initializes the loading process for the banks. Called once on `Event Begin`, uses the `Load Sample Data` variable for the `Load Bank` node.
Check Banks Load
  Checks the `Done` variable every tick. If it is still false, it will iterate through the array of banks incrementing the variable `Number of Loaded Banks`. Once `Number of Loaded Banks` is equal to the total number of banks in the array then the variable `Done` is set to true, and it is safe to load the playable Map.